
import numpy as np
from numpy import zeros, isreal, reshape, real, imag
from proxtoolbox.utils.size import size_matlab
from proxtoolbox.utils.cell import Cell, isCell
import importlib
import copy

class GenericAccelerator:
    """
    Generic Nesterov-type accelerator for first-order methods

    Based on Matlab code written by Russell Luke (Inst. Fuer 
    Numerische und Angewandte Mathematik, Universitaet
    Gottingen) on April 5, 2018.    
    """
    
    def __init__(self, experiment):
        self.u_old = None


    def evaluate(self, u, alg):
        """
        Evaluation of generic Nesterov-type accelerator
        for first-order methods
       
        Parameters
        ----------
        u : ndarray or a cell of ndarray objects
            The point to be accelerated.
        alg : Algorithm object
            The algorithm that uses this accelerator

        Returns
        -------
        u_new : ndarray or a cell of ndarray objects
            (same type as input parameter u)
            The step generated by this acceleration method
            (same type as input parameter `u`).
        """

        if self.u_old is None:
            self.u_old = copy.deepcopy(u)  # use deep copy because we may have a cell of arrays

        s_k = (alg.iter)/(alg.iter+3)

        if isCell(u):
            len_u = len(u)
            u_tmp = Cell(len_u)
            for j in range(len_u):
                u_tmp[j] = u[j].copy()
                u[j] = (s_k+1)*u_tmp[j] - s_k*self.u_old[j]
        else:
            u_tmp = u.copy()
            u = (s_k+1)*u_tmp - s_k*self.u_old

        self.u_old = u_tmp
        return u



